<!--
  ConsoleLogViewer: Component that displays filtered console logs.
  Props:
  - jobId: Identifier of the job whose logs are to be displayed.
  - projectId: Identifier of the project associated with the job. Passed by the parent.
  - isVisible: Boolean that controls the visibility of the component. default: true
  - filterLevel: Log filtering level (e.g., 'info', 'warn', 'error'). default: 'all'
  - searchQuery: String used to filter logs by search query. default: ''

  <ConsoleLogViewer
  :jobId="job.id"
  :projectId="project.id"
  />
  <ConsoleLogViewer
  :jobId="job.id"
  :projectId="project.id"
  :isVisible="IsConsoleVisible"
  :filterLevel="filterLevel"
  :searchQuery="searchQuery"
  />

  TODO: Ensure the parent component and projectId
-->

<script setup lang="ts">
import { nextTick, onBeforeMount, onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { AnsiUp } from 'ansi_up'
import GitApi from '@/api/gitApi'

const props = defineProps({
  jobId: {
    type: Number,
    required: true,
  },
  projectId: {
    type: Number,
    required: true,
  },
  isVisible: {
    type: Boolean,
    default: true,
  },
  filterLevel: {
    type: String,
    default: 'all',
  },
  searchQuery: {
    type: String,
    default: '',
  },
})

// Refs
const ansi = ref<AnsiUp>(new AnsiUp())
const user = ref<{ username: string; rol: string }>({ username: '', rol: '' })
const logFileData = ref<string[]>([])
const processedValues = ref<string[]>([])
const refreshKey = ref<number>(0)
const logContainer = ref<HTMLElement | null>(null) // Referencia al contenedor de logs

const route = useRoute()
const store = useStore()

// Watchers
watch(
  () => route.query.searchButton,
  () => {
    refreshKey.value += 1
  },
)

onBeforeMount(() => {
  ansi.value = new AnsiUp()
})

onMounted(() => {
  console.log('Props projectId:', props.projectId) // Asegúrate de que projectId es correcto al montar el componente
  user.value = store.state.user
  getJobLog()
})

// Desplazar hacia abajo después de cargar los logs
const scrollToBottom = () => {
  nextTick(() => {
    if (logContainer.value)
      logContainer.value.scrollTop = logContainer.value.scrollHeight
  })
}

const getJobLog = async (): Promise<void> => {
  const git = new GitApi()

  try {
    console.log('Fetching logs with projectId:', props.projectId, 'and jobId:', props.jobId)

    const response = await git.getLog(String(props.projectId), String(props.jobId))

    logFileData.value = response.data
    await processLogs()
    scrollToBottom() // Llamada para desplazar hacia abajo
  }
  catch (error) {
    console.error('Console error while fetching logs:', error)
  }
}

const processLogs = async (): Promise<string[]> => {
  if (!logFileData.value)
    return []

  const logData = applyANSIFormatting(logFileData.value)
  const data = ansi.value.ansi_to_html(logData).split(/\n/gm)

  processedValues.value = data.map(value =>
    value.replace(/^section_(end|start):[0-9,:,\w]+/gm, '').replace('\r', ''),
  )

  return processedValues.value
}

const applyANSIFormatting = (logComplete: string): string => {
  const whiteColor = '\u001B[37m'
  const endColor = '\u001B[0m'

  const processedLines = logComplete
    .split(/\n/gm)
    .map(originalLine => {
      const lineWithoutOK = originalLine.replace(/\u001B\[0K/g, '')
      const cleanLine = lineWithoutOK.replace(/[\r\n]+/g, '')
      const lineWithoutSections = cleanLine.replace(/^section_(end|start):[0-9,:\w]+/gm, '')

      const matchesStartColor = lineWithoutSections.match(/^\u001B\[(\d+;*\d*)m(?!0)/)
      const matchesEndColor = lineWithoutSections.match(/\u001B\[0;*m$/)

      if (matchesStartColor && matchesEndColor) {
        return cleanLine
      }
      else if (matchesStartColor && !matchesEndColor) {
        const ANSIcode1 = matchesStartColor[1]
        const startColor = `\u001B[${ANSIcode1}m`

        return `${startColor}${cleanLine}${endColor}`
      }
      else if (!matchesStartColor && matchesEndColor) {
        return `${whiteColor}${cleanLine}`
      }

      return `${whiteColor}${cleanLine}${endColor}`
    })
    .filter(line => line.trim().length !== 0)

  return processedLines.join('\n')
}

const hiddenLines = (log: string): boolean => {
  const colorFilter = props.filterLevel.toLowerCase()
  const searchFilter = props.searchQuery.toLowerCase()
  const logLower = log.toLowerCase()

  if (colorFilter === 'all' && searchFilter === '')
    return true

  const filterLevelBool = colorFilter !== 'all' && logLower.includes(colorFilter)
  const searchQueryBool = searchFilter !== '' && logLower.includes(searchFilter)

  return filterLevelBool || searchQueryBool
}

const highLight = (log: string): string => {
  const colorFilter = props.filterLevel.toLowerCase()
  const searchFilter = props.searchQuery.toLowerCase()
  let highlightedLog = log

  if (colorFilter !== 'all') {
    highlightedLog = highlightedLog.replace(
      new RegExp(colorFilter, 'gi'),
      match => `<span style="font-size: 14px; background-color: gold; font-weight: bold; color: black;">${match}</span>`,
    )
  }

  if (searchFilter !== '') {
    highlightedLog = highlightedLog.replace(
      new RegExp(searchFilter, 'gi'),
      match => `<span style="font-size: 14px; background-color: gold; font-weight: bold; color: black;">${match}</span>`,
    )
  }

  return highlightedLog
}
</script>

<template>
  <VCardText
    v-show="isVisible && processedValues.length > 0"
    ref="logContainer"
    class="m-0 p-0 console-container"
  >
    <div
      :key="refreshKey"
      class="console py-1"
    >
      <div
        v-for="(log, index) in processedValues"
        :key="index"
        class="log-line"
      >
        <div v-if="hiddenLines(log)">
          <div
            class="d-inline mr-4 ml-4 index"
            v-html="index + 1"
          />
          <div
            class="d-inline overflow-x-auto my-0 console"
            v-html="highLight(log)"
          />
        </div>
      </div>
    </div>
  </VCardText>
</template>

<style scoped>
.console-container {
  height: 400px; /* Altura fija para la consola */
  overflow-y: auto; /* Permite el desplazamiento vertical */
  background-color: #111; /* Fondo negro para simular una consola */
  color: #fff; /* Texto blanco */
}

.console {
  font-family: monospace;
  text-align: left;
  white-space: pre-wrap;
  font-size: 11px; /* Ajusta este valor según tus necesidades */
  line-height: 1.2; /* Ajusta el interlineado aquí */
}

.index {
  color: #6e6b7b;
  min-width: 4% !important;
  text-align: right;
}
</style>
